// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <libgdamm/datamodelarray.h>
#include <libgdamm/private/datamodelarray_p.h>


// -*- C++ -*- // this is for the .ccg, I realize gensig puts one in

/* datamodelarray.cc
 * 
 * Copyright 2003 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgda/gda-data-model-array.h>

namespace Gnome
{

namespace Gda
{

DataModelArray::DataModelArray(int cols)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(datamodelarray_class_.init(), "n-columns",cols, static_cast<char*>(0)))
{
}

void DataModelArray::set_column_g_type(int col, GType type)
{
  //This is based on the code in gda_data_model_array_new_with_g_type():
  gda_column_set_g_type (gda_data_model_describe_column (GDA_DATA_MODEL(gobj()), col), type);
}

} /* namespace Gda */

} /* namespace Gnome */


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gnome::Gda::DataModelArray> wrap(GdaDataModelArray* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Gda::DataModelArray>( dynamic_cast<Gnome::Gda::DataModelArray*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Gda
{


/* The *_Class implementation: */

const Glib::Class& DataModelArray_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &DataModelArray_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gda_data_model_array_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  DataModel::add_interface(get_type());

  }

  return *this;
}


void DataModelArray_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* DataModelArray_Class::wrap_new(GObject* object)
{
  return new DataModelArray((GdaDataModelArray*)object);
}


/* The implementation: */

GdaDataModelArray* DataModelArray::gobj_copy()
{
  reference();
  return gobj();
}

DataModelArray::DataModelArray(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

DataModelArray::DataModelArray(GdaDataModelArray* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


DataModelArray::DataModelArray(DataModelArray&& src) noexcept
: Glib::Object(std::move(src))
  , DataModel(std::move(src))
{}

DataModelArray& DataModelArray::operator=(DataModelArray&& src) noexcept
{
  Glib::Object::operator=(std::move(src));
  DataModel::operator=(std::move(src));
  return *this;
}

DataModelArray::~DataModelArray() noexcept
{}


DataModelArray::CppClassType DataModelArray::datamodelarray_class_; // initialize static member

GType DataModelArray::get_type()
{
  return datamodelarray_class_.init().get_type();
}


GType DataModelArray::get_base_type()
{
  return gda_data_model_array_get_type();
}


Glib::RefPtr<DataModelArray> DataModelArray::create(int cols)
{
  return Glib::RefPtr<DataModelArray>( new DataModelArray(cols) );
}

void DataModelArray::set_n_columns(int cols)
{
  gda_data_model_array_set_n_columns(gobj(), cols);
}

void DataModelArray::clear()
{
  gda_data_model_array_clear(gobj());
}

Glib::RefPtr<Row> DataModelArray::get_row(int row)
{
  GError* gerror = nullptr;
  Glib::RefPtr<Row> retvalue = Glib::wrap(gda_data_model_array_get_row(gobj(), row, &(gerror)));
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
  return retvalue;
}

Glib::RefPtr<const Row> DataModelArray::get_row(int row) const
{
  GError* gerror = nullptr;
  Glib::RefPtr<const Row> retvalue = Glib::wrap(gda_data_model_array_get_row(const_cast<GdaDataModelArray*>(gobj()), row, &(gerror)));
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
  return retvalue;
}


Glib::PropertyProxy< guint > DataModelArray::property_n_columns() 
{
  return Glib::PropertyProxy< guint >(this, "n-columns");
}

Glib::PropertyProxy_ReadOnly< guint > DataModelArray::property_n_columns() const
{
  return Glib::PropertyProxy_ReadOnly< guint >(this, "n-columns");
}


} // namespace Gda

} // namespace Gnome


